<?php

namespace Drupal\peertube\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Configure peertube settings for this site.
 */
class PeertubeSettingsForm extends ConfigFormBase {
  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'peertube_settings';
  }

  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    return [
      'peertube.settings',
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $config = $this->config('peertube.settings');

    $form['peertube_instances'] = array(
      '#type' => 'textarea',
      '#title' => $this->t('Peertube instances'),
      '#default_value' => $config->get('peertube_instances'),
      '#description' => $this->t('Contribute all the domain names of the PeerTube instances you want to use. For now, only the last one will be supported due to a core issue.'),
    );

    return parent::buildForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $this->configFactory->getEditable('peertube.settings')
      ->set('peertube_instances', $form_state->getValue('peertube_instances'))
      ->save();

    parent::submitForm($form, $form_state);
  }
}
